#include "stdint.h"

typedef struct IIC_Simulate_Phy_Type
{
    
}IIC_Simulate_Phy_TypeDef;

typedef struct IIC_Type
{
    void * iic_phy;
    void (*IIC_Init)(const struct IIC_Type *iic);
    void (*IIC_Start)(const struct IIC_Type *iic);
    void (*IIC_Stop)(const struct IIC_Type *iic);
    void (*IIC_Send_Byte)(const struct IIC_Type *iic, uint8_t data);
    uint8_t (*IIC_Read_Byte)(const struct IIC_Type *iic);
} IIC_TypeDef;

typedef struct AT24CXX_Type
{
    uint8_t type;
    uint8_t device_address;
    IIC_TypeDef *iic_bus;
    void (*AT24CXX_Init)(const struct AT24CXX_Type *eeprom);
    void (*AT24CXX_Check)(const struct AT24CXX_Type *eeprom);
    uint8_t (*AT24CXX_ReadOneByte)(const struct AT24CXX_Type *eeprom, const uint16_t address);
    void (*AT24CXX_WriteOneByte)(const struct AT24CXX_Type *eeprom, const uint16_t address, const uint8_t data);
    uint16_t (*AT24CXX_ReadLenBytes)(const struct AT24CXX_Type *eeprom, const uint16_t address, const uint16_t len, uint8_t *pdata);
    uint16_t (*AT24CXX_WriteLenBytes)(const struct AT24CXX_Type *eeprom, const uint16_t address, const uint16_t len, const uint8_t *pdata);
} AT24CXX_TypeDef;
